/*	Renegade Scripts.dll
	ArKa_47 Bank Plugin
	Copyright 2021 ArKa_47, Shadow-Team

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/

#ifndef ARKABANK_H
#define ARKABANK_H

// ----------- so to speak  interface ---------------------------------------------------------
class ArKaBankInterface abstract{ 
protected:
	ArKaBankListClass* bankList;
	const char* SettingsFileName;

};

// -------------------- EVENT CLASS -----------------------------------------------------------------
class ArKaBankEventClass : public DAEventClass , private ArKaBankInterface {
public:
	ArKaBankEventClass();
	~ArKaBankEventClass();
	void Game_Over_Event();
	void Level_Loaded_Event();

	void Settings_Loaded_Event();

	const DASettingsClass* Settings;

	void Load_settings();
};


// -------------------- BANK CLASS  --------------------------------------------------------------
class ArKaBankClass : private ArKaBankInterface {
public:
	ArKaBankClass();
	~ArKaBankClass();
	ArKaBankListClass* Get_BankList();

private:
	ArKaBankEventClass* bankEvent;

};

// -------------------- CHAT COMMAND CLASS  ---------------------------------------------------------
class ArKaBankChatCommandClass : public DAChatCommandClass, private ArKaBankInterface {
public:
	ArKaBankChatCommandClass();
	~ArKaBankChatCommandClass();
	bool Activate(cPlayer* Player, const DATokenClass& Text, TextMessageEnum ChatType);

};

#endif