/*	Renegade Scripts.dll
	ArKa_47 Bank Plugin
	Copyright 2021 ArKa_47, Shadow-Team

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/

#ifndef ARKABANKSYSTEM_H
#define ARKABANKSYSTEM_H

// inspired by DA Ban Manager



//	GetLocalTime(); kinda time based taxes_ idea


// Class for every single entry
class ArKaBankEntryClass {
public:

	ArKaBankEntryClass(const char* playerName, const char* playerHash, const char* stringBalance);
	static StringClass Get_Hash_by_PlayerName(const char* playerName);
	const StringClass Get_Name();
	const StringClass Get_Player_Hash();
	const StringClass Get_Balance();
	bool Matches_Name(const char* playerName);
	bool Matches_PlayerHash(const char* playerHash);
	void Set_Balance(const char* stringBalance);

private:
	StringClass playerName;
	StringClass playerHash; // using SerialHash instead of the clear serial to avoid abusing (smart or dumb?)
	int balance;
	StringClass stringBalance;
};

// Class to manage the list of entries as well as load/save them from/into a file
class ArKaBankListClass {
public:
	ArKaBankListClass(const char* FileName); // primary method
	ArKaBankListClass();
	~ArKaBankListClass();

	void Load();
	void Save();
	void Add_Money(cPlayer* Player, float money);  
	void Remove_Money(cPlayer* Player, float money); 
	void Print_Info(cPlayer* Player);
	void Print_AccountInfo(cPlayer* Player);
	bool Has_Account(cPlayer* Player);
	float Get_Balance(cPlayer* Player);
	void Set_MaxAmount(float maxAmount);
	float Get_MaxAmount();
	void Load_Settings(); // Reads and takes over settings defined in .ini file

private:
	// Previous public methods ----just in case there are some errors -----------------------------------------

	static float StringToFloat(const char* String);
	void Remove_Entry(const char* playerHash);
	int Get_Count();
	ArKaBankEntryClass* Find_Entry_by_Name(const char* playerName);
	ArKaBankEntryClass* Find_Entry_by_PlayerHash(const char* playerHash);
	ArKaBankEntryClass* Add_Entry(const char* playerName, const char* playerHash, const char* stringBalance); //Primary method
	ArKaBankEntryClass* Add_Entry(StringClass Format); // used Player->Get_Name();  -> maybe better Get_PlayerName_by_ID();
	void Update_Balance(const char* playerHash, const char* stringBalance); // ever used?
	bool Hash_Exist(const char* playerHash);
	//- ----------------------------------------------------------------------------------------------------
	void Delete_Empty_Accounts();
	StringClass FileName;
	unsigned int LastModTime;
	DynamicVectorClass<ArKaBankEntryClass*> List;
	float MaxAmount;




};






#endif;